# This is a sample Python script.

# Press Shift+F10 to execute it or replace it with your code.
# Press Double Shift to search everywhere for classes, files, tool windows, actions, and settings.
from itertools import product

import findspark
findspark.init()
import warnings
import pandas as pd
import numpy as np
from sklearn.model_selection import TimeSeriesSplit
from statsmodels.graphics.tsaplots import plot_acf
from statsmodels.tsa.ar_model import AR, AR_DEPRECATION_WARN
from statsmodels.tsa.arima_model import ARIMA
from sklearn.metrics import mean_squared_error
import statsmodels.api as sm
import statistics as stat
import itertools
import operator

from pyspark import SparkContext

import matplotlib.pyplot as plt
import math
import seaborn as sns
from sklearn.cluster import KMeans
import ts_functions as ts
from abc_analysis import abc_analysis, abc_plot
from datetime import datetime




def print_hi():
    # Use a breakpoint in the code line below to debug your script.
    sc = SparkContext("local", "phase1")
    sc.setLogLevel("OFF")
    rdd = sc.textFile("C:\\bigD\\master\\DATA_2019_lek.csv")
    row_split = rdd.map(lambda x: x.split(";"))
    date_pallettype_sku_expiery = row_split.map(lambda x:(x[0], x[2], x[50],x[42], x[27]))
    reducing_date = date_pallettype_sku_expiery.map(lambda x:(x[0].split(" ")[0], x[1], x[2],x[3],x[4]))

    schema = ["Reg-Dato","Log-kode","Varenr","Bedst-før","Antal"]


    filtering_data = reducing_date.filter(lambda x:(x[1] == "18" ))
    # print(filtering_data.collect())
    strip_filtering_data = filtering_data.map(lambda x:(x[0].strip("' "),x[1].strip("' "),x[2].strip("' "),x[3].strip("' "),x[4].strip("' ")))
    # print(strip_filtering_data.collect())

    grouping_data = filtering_data.map(lambda x: ((x[0], x[2]), float(x[4].replace(',','.'))))

    # print(grouping_data.collect())

    # strip_grouping_data

    reducing_grouped_data= grouping_data.reduceByKey(lambda x,y: (x+ y))
    print(reducing_grouped_data.collect())

    date_sku_nr_data = reducing_grouped_data.map(lambda x: (x[0][0], x[0][1].strip(), x[1]))


    print(date_sku_nr_data.collect())
    date_sku_nr_data.coalesce(1).saveAsTextFile("data1")

    # sparkDf = date_sku_nr_data.toDF()
    #
    # pdDf = sparkDf.toPandas()




    # level_data = reducing_grouped_data.map(lambda x: (x[0], x[1], x[0][]))

    # df = sc.createDataFrame(data=simpleData, schema = schema)
    # reducing_days_and_Sku_data =filtering_data.reduce(lambda x,y: x+y)


    #df = pd.read_csv('/bigD/master/DATA_2019.csv',error_bad_lines=False)
    # df= pd.read_excel('/bigD/master/DATA_2019.xlsx')




    # print(df)
    # print(row_split.take(10))
    # print("col")
    # print(reducing_date.take(10))
    # print("filter")
    # print(filtering_data.take(10))
    # print("reduced")
    # # print(reducing_days_and_Sku_data.take(10))
    #
    # print(grouping_data.take(10))
    # print(reducing_grouped_data.take(10))
    # print(date_sku_nr_data.take(10))

    # print(sparkDf)
    # print(pdDf)

    # for row in reducing_grouped_data.collect():
    #     print(row[0] + "," +str(row[1]))
    #row_split = rdd.map(lambda x: x.split(" "))
    #columns = row_split.map(lambda x: (x[0], (round(((float (x[7]) + float (x[8]) + float (x[9]))/3),1))))

#groups = columns.reduceByKey(lambda x : (x))

    #sortedGroups = columns.sortBy(lambda x: ( (-x[1])))

    #print(sortedGroups.take(10))
     # Press Ctrl+F8 to toggle the breakpoint.

def from_text_to_df():
    print('text')
    pd.set_option('display.max_rows', 1000)
    df = pd.read_csv('data/part-00000')
    df.columns = df.columns.str.replace('[()]', '')
    df = df.replace('[()]', '', regex=True)

    print(df)


    list_of_skus= df['sku'].unique()

    # plot_every_sku(list_of_skus,df.copy())

    statement =plot_monthly_data(list_of_skus,df.copy())
    print(statement)

    # statment_df = pd.DataFrame(data=statement)
    #
    # print("hey",statment_df)
    # print(statment_df.keys(), statment_df.items())
    # print(statment_df.sort_values(by=['nr']))
# # print(list_of_skus[0])
    # dates_and_nr__of_sku_1= df.loc[df['sku'] == list_of_skus[3]]
    #
    # # print(dates_and_nr__of_sku_1.keys())
    #
    # dates_and_nr = dates_and_nr__of_sku_1.drop(['sku'],axis=1)
    # # dates_and_nr_without_index= dates_and_nr.index.drop()
    # print(dates_and_nr)
    # # dates_and_nr__of_sku_1
    #
    # dates_and_nr.index = pd.to_datetime(dates_and_nr['date'])
    # dates_and_nr_with_indexdate = dates_and_nr.drop(['date'],axis=1)
    # dates_and_nr_with_indexdate_and_floatnr= dates_and_nr_with_indexdate.applymap(lambda x: float(x.strip().replace("'", '')))
    # dates_and_nr_with_indexdate_and_floatnr_sorted =dates_and_nr_with_indexdate_and_floatnr.sort_index()
    #
    # # for number in dates_and_nr_with_indexdate["nr"]:
    # #     if (isinstance(number, str)):
    # #         print(float(number.strip().replace("'", '')))
    # #         # print(float(number.replace('[()]', '', regex=True)))
    #
    # # dates_and_nr_with_indexdate['nr']= pd.to_numeric(dates_and_nr_with_indexdate['nr'],errors='coerce')
    # print(dates_and_nr)
    # print(dates_and_nr_with_indexdate)
    # print(dates_and_nr_with_indexdate_and_floatnr_sorted)
    # # print(dates_and_nr_with_indexdate_and_floatnr)
    # dates_and_nr_with_indexdate_and_floatnr_sorted.plot()
    #
    # # plt.figure(figsize=(3*ts.HEIGHT, ts.HEIGHT))
    # # ts.plot_series(dates_and_nr_with_indexdate_and_floatnr, x_label='date', y_label='nr', title="hey")
    # # plt.xticks(rotation = 45)
    # # plt.show()
    # #
    # #
    # data = pd.read_csv('data/ashrae_single.csv', index_col='timestamp', sep=',', decimal='.',
    #                    parse_dates=True, infer_datetime_format=True)
    #
    # print(data)
    # # #
    # # plt.figure(figsize=(3*ts.HEIGHT, ts.HEIGHT))
    # # ts.plot_series(data, x_label='date', y_label='nr', title="hey")
    # # plt.xticks(rotation = 45)
    # plt.show()


    # print(dates_and_nr__of_sku_1)


def plot_every_sku(skuList, df):
    # plt.rcParams.update({'figure.max_open_warning': 0})
    for sku in skuList:
        dates_and_nr_of_sku= df.loc[df['sku'] == sku]
        dates_and_nr = dates_and_nr_of_sku.drop(['sku'],axis=1)
        dates_and_nr.index = pd.to_datetime(dates_and_nr['date'])
        dates_and_nr_with_indexdate = dates_and_nr.drop(['date'],axis=1)
        dates_and_nr_with_indexdate_and_floatnr= dates_and_nr_with_indexdate.applymap(lambda x: float(x.strip().replace("'", '')))
        dates_and_nr_with_indexdate_and_floatnr_sorted =dates_and_nr_with_indexdate_and_floatnr.sort_index()

        print(sku, dates_and_nr_with_indexdate_and_floatnr_sorted)
        # dates_and_nr_with_indexdate_and_floatnr_sorted.plot()

        # plt.title(sku)
    # plt.show()

def plot_fake_data():
    data = pd.read_csv('data/ashrae_single.csv', index_col='timestamp', sep=',', decimal='.',
                        parse_dates=True, infer_datetime_format=True)


    # data.plot()
    # plt.show()


def plot_monthly_data(skuList, df):
    plt.rcParams.update({'figure.max_open_warning': 0})
    salesdict = {}
    for sku in skuList:
        dates_and_nr_of_sku= df.loc[df['sku'] == sku]
        dates_and_nr = dates_and_nr_of_sku.drop(['sku'],axis=1)
        dates_and_nr.index = pd.to_datetime(dates_and_nr['date'])
        dates_and_nr_with_indexdate = dates_and_nr.drop(['date'],axis=1)
        dates_and_nr_with_indexdate_and_floatnr= dates_and_nr_with_indexdate.applymap(lambda x: float(x.strip().replace("'", '')))
        dates_and_nr_with_indexdate_and_floatnr_sorted =dates_and_nr_with_indexdate_and_floatnr.sort_index()

        # dette er feil om må fikses, finner gjennomstittet i måneden og det hjelper ikke meg med noe
        index = dates_and_nr_with_indexdate_and_floatnr_sorted.index.to_period('M')
        month_df = dates_and_nr_with_indexdate_and_floatnr_sorted.copy().groupby(index).sum()

        # salesdict[sku] =month_df.apply(np.sum, axis= 0)
        # print(sku, month_df)
        salesdict[sku] = month_df.agg('sum')


        # print(month_df.agg('sum'))
        # month_df['timestamp'] = index.drop_duplicates().to_timestamp()
        # month_df.set_index('timestamp', drop=True, inplace=True)
        # plt.show()
    # salesdict_sorted = sorted(salesdict.values(), key=lambda kv: kv[1])
    print(salesdict)

    return salesdict


def yearly_most_sales(df):

    pd.set_option('display.max_rows', None)

    df['nr']= df['nr'].apply(lambda x: float(x.strip().replace("'", '')))

    # print(df)

    df_most_sales= df.groupby(['sku'], as_index=False)['nr'].sum()
    #
    sorted_df = df_most_sales.sort_values(by=['nr'],ascending=True  )

    print(sorted_df)


def plot_a_sku(df ,sku):

    print("skoda", sku)
    print(df)
    plt.rcParams.update({'figure.max_open_warning': 0})

    df['sku']= df['sku'].apply(lambda x: x.strip())

    dates_and_nr_of_sku= df.loc[df['sku'] == sku.strip()]

    print(dates_and_nr_of_sku)
    # print(dates_and_nr_of_sku)

    dates_and_nr = dates_and_nr_of_sku.drop(['sku'],axis=1)
    dates_and_nr['date'] = dates_and_nr['date'].apply(lambda x: x.strip())
    dates_and_nr.index = pd.to_datetime(dates_and_nr['date'], dayfirst=True)
    dates_and_nr_with_indexdate = dates_and_nr.drop(['date'],axis=1)
    dates_and_nr_with_indexdate_and_floatnr= dates_and_nr_with_indexdate.applymap(lambda x: float(x))
    dates_and_nr_with_indexdate_and_floatnr_sorted =dates_and_nr_with_indexdate_and_floatnr.sort_index()
    # print(dates_and_nr_with_indexdate_and_floatnr_sorted)

    # dates_and_nr_with_indexdate_and_floatnr_sorted.plot()
    # print(dates_and_nr_with_indexdate_and_floatnr_sorted, "hva da")
    # plt.title(sku)
    # plt.show()

    return dates_and_nr_with_indexdate_and_floatnr_sorted
# def get_most_selling_sku_pr_month(salesdict):
#
#

# def get_most_selling_sku_pr_year(df):
#
#     df.

def forcast_of_sku(df_time_series):
    print(df_time_series)

    warnings.filterwarnings('ignore', 'statsmodels.tsa.ar_model.AR', FutureWarning)

    warnings.warn(AR_DEPRECATION_WARN, FutureWarning)


    index = df_time_series.index.to_period('W')
    week_df = df_time_series.copy().groupby(index).sum()

    # print(new_df)
    # print(df_time_series)

    # # plot_acf(month_df)
    # # real_name = month_df.index.name
    print(len(week_df))

    # plot_acf(week_df)

    sales_diff = week_df.diff(periods=1)
    sales_diff = sales_diff[1:]
    print(sales_diff)

    # plot_acf(sales_diff)
    # sales_diff.plot()

    X = week_df.values
    train = X[0:90] # 42 data as train data
    test = X[89:]  # 21 data as test data
    predictions = []

    model_ar = AR(train)
    model_ar_fit = model_ar.fit()

    predictions = model_ar_fit.predict(start=90,end=104)

    print(len(predictions))
    print(len(test))
    #
    plt.plot(test, color = 'green')
    plt.plot(predictions,color='red')

    # plt.legend(["Dataset 1", "Dataset 2"])

    # plt.show()

def forcast_of_sku_arima(df_time_series):


    warnings.filterwarnings('ignore', 'statsmodels.tsa.ar_model.AR', FutureWarning)

    warnings.warn(AR_DEPRECATION_WARN, FutureWarning)


    index = df_time_series.index.to_period('W')
    week_df = df_time_series.copy().groupby(index).sum()




    sales_diff = week_df.diff(periods=1)
    sales_diff = sales_diff[1:]
    print(sales_diff)

    # plot_acf(sales_diff)
    # sales_diff.plot()

    X = week_df.values
    train = X[0:95] # 42 data as train data
    test = X[94:]  # 21 data as test data
    predictions = []

    # p,d,q = vars
    # p = periods in AR
    # d = integration order
    # q = periods in MA


    model_arima = ARIMA(train,order=(10,1,4))
    model_arima_fit = model_arima.fit()
    print(model_arima_fit.aic)

    # minumum value of aic is the best

    predictions= model_arima_fit.forecast(steps=10)[0]

    print(predictions)

    plt.plot(test)
    plt.plot(predictions,color='red')

    # plt.show()

    mean_squared_error(test,predictions)
    p=d=q=range(0,15)
    pdq = list(itertools.product(p,d,q))
    resultlist_pdq= []
    score = 1947.1901369255856
    best_param = ''
    warnings.filterwarnings('ignore')



    # for param in pdq:
    #     try:
    #         model_arima = ARIMA(train,order=param)
    #         model_arima_fit = model_arima.fit()
    #         print(param,math.floor(model_arima_fit.aic))
    #         resultlist_pdq.append((param,model_arima_fit.aic))
    #         if score > model_arima_fit.aic:
    #             score= model_arima_fit.aic
    #             best_param = param
    #     except:
    #         continue
    #
    # with open('10_predict_arima.txt', 'w') as f:
    #
    #     f.write('\n'.join('{} {}'.format(x[0],x[1]) for x in resultlist_pdq))
    #
    # f.close()


    print('result', best_param, score)

def forcast_of_new_sku_arima(df_time_series):


    warnings.filterwarnings('ignore', 'statsmodels.tsa.ar_model.AR', FutureWarning)

    warnings.warn(AR_DEPRECATION_WARN, FutureWarning)

    mydates = pd.date_range('01-01-19', '31-12-20').to_series().to_frame()
    # print((mydates))
    mydates[0] = 0
    # print('dates',mydates)
    mydates.rename(columns ={0: 'nr'} , inplace = True)
    # print(mydates)

    df_time_series = df_time_series.copy().append(mydates)

    print("suppe",df_time_series)

    index = df_time_series.index.to_period('W')
    week_df = df_time_series.copy().groupby(index).sum()
    # print(df_time_series)
    print(week_df)
    print(len(week_df))





    sales_diff = week_df.diff(periods=1)
    sales_diff = sales_diff[1:]
    print(sales_diff)

    # plot_acf(week_df)
    # sales_diff.plot()

    X = week_df.values
    train = X[0:95] # 42 data as train data
    test = X[94:]  # 21 data as test data
    predictions = []

    print(len(train))
    print(len(test))

    # p,d,q = vars
    # p = periods in AR
    # d = integration order
    # q = periods in MA


    model_arima = ARIMA(train,order=(7,2,2))
    model_arima_fit = model_arima.fit()
    print(model_arima_fit.aic)

    # minumum value of aic is the best

    predictions= model_arima_fit.forecast(steps=10)[0]

    print(predictions)

    plt.plot(test)
    plt.plot(predictions,color='red')

    # plt.show()

    mean_squared_error(test,predictions)
    p=q=range(0,10)
    d= range(0,3)
    pdq = list(itertools.product(p,d,q))
    resultlist_pdq= []
    score = 999999;
    best_param = ''
    warnings.filterwarnings('ignore')



    # for param in pdq:
    #     try:
    #         model_arima = ARIMA(train,order=param)
    #         model_arima_fit = model_arima.fit()
    #         print(param,math.floor(model_arima_fit.aic))
    #         resultlist_pdq.append((param,model_arima_fit.aic))
    #         if score > model_arima_fit.aic:
    #             score= model_arima_fit.aic
    #             best_param = param
    #     except:
    #         continue
    # #
    # with open('10_predict_arima_100295.txt', 'w') as f:
    #
    #     f.write('\n'.join('{} {}'.format(x[0],x[1]) for x in resultlist_pdq))
    #
    # f.close()


    print('result', best_param, score)

def making_week_df_and_split_into_train_and_testr(df_time_series,sku):

    warnings.filterwarnings('ignore', 'statsmodels.tsa.ar_model.AR', FutureWarning)

    warnings.warn(AR_DEPRECATION_WARN, FutureWarning)

    mydates = pd.date_range('01.01.19', '31.12.20').to_series().to_frame()
    # print((mydates, "wario"))
    mydates[0] = 0
    # print('dates',mydates)
    mydates.rename(columns ={0: 'nr'} , inplace = True)
    print(mydates)
    print(df_time_series, "pre")
    df_time_series = df_time_series.append(mydates)
    print(df_time_series, "flaske")
    # print(df_time_series)

    pd.set_option('display.max_rows', 1000)
    index = df_time_series.index.to_period('W')
    print("index", index)
    week_df = df_time_series.groupby(index).sum()
    pd.set_option('display.max_rows', 1000)
    # print(df_time_series)
    print("kake",week_df)
    print(len(week_df))


    week_df.plot(label = 'SKU')
    plt.title(sku)
    plt.ylabel('Nr of full pallets picked')
    plt.show()

    # sales_diff = week_df.diff(periods=1)
    # sales_diff = sales_diff[1:]
    # print(sales_diff)

    # plot_acf(week_df)
    # sales_diff.plot()

    X = week_df.values
    train = X[0:95] # 95 data as train data
    test = X[94:]  # 10 data as test data



    return train,test

def forcast_a_sku_SARIMAX(train):

    data = train

    # Grid Search
    p = d = q = range(0,2) # p, d, and q can be either 0, 1, or 2
    pdq = list(itertools.product(p,d,q)) # gets all possible combinations of p, d, and q
    p2 = d2 = q2 = range(0, 2) # second set of p's, d's, and q's
    pdq2 = list(itertools.product(p2,d2,q2)) # simular too code above but for seasonal parameters
    s = 4 # here I use twelve but the number here is representative of the periodicty of the seasonal cycle
    pdqs2 = [(c[0], c[1], c[2], s) for c in pdq2]
    combs = {}
    aics = []# Grid Search Continued
    for combination in pdq:
        for seasonal_combination in pdqs2:
            try:
                model = sm.tsa.statespace.SARIMAX(data, order=combination, seasonal_order=seasonal_combination,
                                                  enforce_stationarity=False,
                                                  enforce_invertibility=False)
                model = model.fit()
                combs.update({model.aic : [combination, seasonal_combination]})
                aics.append(model.aic)

            except:
                continue

    best_aic = min(aics)# Modeling and forcasting
    model = sm.tsa.statespace.SARIMAX(data, order=combs[best_aic][0], seasonal_order=combs[best_aic][1],
                                      enforce_stationarity=False,
                                      enforce_invertibility=False)
    model = model.fit()
    forecast = model.forecast(11)
    print(forecast, "siv")
    return forecast

def plot_predicted_value_and_test(forecast, test ):
    plt.ylabel('Nr of full pallets picked')
    plt.xlabel('Nr of weeks')
    plt.plot(test, color ='green', label = "test data")
    plt.plot(forecast,color='red', label = "forecast")
    plt.legend(loc="upper left")

    plt.show()

def sarimax_run(df, sku):
    # df = pd.read_csv('data1/part-00000')
    # df.columns = df.columns.str.replace('[()]', '')
    # df = df.replace('[()]', '', regex=True)
    df_time_series= plot_a_sku(df.copy(),sku)
    # print("sher4prez",len(df_time_series))

    train,test = making_week_df_and_split_into_train_and_testr(df_time_series, sku)

    # print(train)
    forecast = forcast_a_sku_SARIMAX(train)

    plot_predicted_value_and_test(forecast,test)

    return forecast


def write_date_and_nr_to_file_to_get_pallet_nr():
    sc = SparkContext("local", "phase1")
    sc.setLogLevel("OFF")
    rdd = sc.textFile("C:\\bigD\\master\\DATA_2020.csv")
    row_split = rdd.map(lambda x: x.split(";"))
    date_pallettype_sku_expiery = row_split.map(lambda x:(x[0], x[2], x[50],x[42], x[27]))
    reducing_date = date_pallettype_sku_expiery.map(lambda x:(x[0].split(" ")[0], x[1], x[2] ,x[4]))
    filtering_data = reducing_date.filter(lambda x:(x[1] == "18" ))
    clean_data= filtering_data.map(lambda x: (x[0].replace("-","."),x[2].strip().replace("'", ''), x[3].strip().replace(",", '.')))

    print(clean_data.take(10))

    # clean_data.coalesce(1).saveAsTextFile("data4")

def make_nr_pr_pallet_dict():
    # pd.set_option('display.max_rows', 1000)
    df = pd.read_csv('data3/part-00000')
    df.columns = df.columns.str.replace('[()]', '')
    df = df.replace('[()]', '', regex=True)
    print(df)


    df['nr']= df['nr'].apply(lambda x: float(x.strip().replace("'", '')))
    df['sku']= df['sku'].apply(lambda x: x.strip().replace("'", ''))
    df_nr= df.groupby(['sku'], as_index=False)['nr'].median()

    dict_df= df_nr.set_index('sku').T.to_dict('list')


    print(dict_df)
    print(dict_df['105544'][0])

    return dict_df


def make_df_with_pallet_nr(df, dict_df):

    # print(df)
    # print(dict_df)

    df['nr'] = df.apply(lambda x: help_function_pallet_making(x, dict_df), axis = 1)

    print(df)

    return df



def help_function_pallet_making(x,dict_df):
    if (dict_df[x[1].strip().replace("'", '')][0] == 0):
        # print('ja', x[2],x[1])
        res = 1
    else:
        res = math.floor(float(x[2].strip().replace("'", ''))/dict_df[x[1].strip().replace("'", '')][0])


    return res

def run_pallet_df_maker(df):

    dict_df = make_nr_pr_pallet_dict()
    pallet_df = make_df_with_pallet_nr(df,dict_df)

    print(pallet_df)
    return pallet_df

def setup():
    pd.set_option('display.max_rows', 1000)
    df = pd.read_csv('data1/part-00000')
    df.columns = df.columns.str.replace('[()]', '')
    df = df.replace('[()]', '', regex=True)

    return df

def setup_data_2020():
    pd.set_option('display.max_rows', 1000)
    df = pd.read_csv('data4/part-00000')
    df.columns = df.columns.str.replace('[()]', '')
    df = df.replace('[()]', '', regex=True)

    return df

def setup_data_2019_2020():
    df = pd.read_csv('data3/part-00000')
    df.columns = df.columns.str.replace('[()]', '')
    df = df.replace('[()]', '', regex=True)

    return df


def data_transformation_for_old_classification():
    print('class')
    df = run_pallet_df_maker(setup_data_2020())
    df_most_sales= df.groupby(['sku'], as_index=False)['nr'].sum()
    #
    sorted_df = df_most_sales.sort_values(by=['nr'],ascending=True  )
    return sorted_df


def abc_clustering():
    print('clust')

    df= data_transformation_for_old_classification()
    # print(df)
    sns.distplot(df['nr'])

    df['order_dist'] = df['nr'].apply(lambda x: make_bins(x))

    pivot_table = pd.pivot_table(df, index = ["order_dist"])
    kmeans = KMeans(n_clusters=3)
    print(pivot_table)
    kmeans.fit(pivot_table)
    pivot_table["category"] = kmeans.labels_
    ABC_dict = {
        0: "A",
        1: "C",
        2: "B"
    }
    pivot_table["ABC"] = pivot_table["category"].apply(lambda x: ABC_dict[x])
    df = pd.merge(df, pivot_table, on = "order_dist", how ="left")

    print(df)

    # print(df.drop(columns=['count_x', 'C']))

def make_bins(x):

    for bar in range(300,1500,200):
        if x <= bar:
            return bar


def traditional_abc(df):
    pd.set_option('display.max_rows', 1000)

    print('tradition')
    df= df.sort_values(by=['nr'], ascending=False)
    df= df.reset_index()
    # print(df)
    df= df.drop(['index'], axis=1)

    print(df)

    abc = abc_analysis(df['nr'], True)
    # print(abc)
    # index position of A, B, and C Videos
    a_index = abc['Aind']
    b_index = abc['Bind']
    c_index = abc['Cind']

    # print(b_index)

    # New Column indicating A, B, or C
    cond_list = [df.index.isin(a_index),
                 df.index.isin(b_index),
                 df.index.isin(c_index)]

    choice_list = ['A','B','C']

    df['abc'] = np.select(cond_list, choice_list)
    df= df.sort_values(by=['nr'], ascending=False)

    print(df)

    return df



def write_forecast_sum_to_file():
    print("forecast to file")
    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    list_of_skus= df['sku'].unique()

    f = open("sarimax_forecast_sum.txt", "a")

    list_of_skus = list_of_skus[600:]

    for sku in list_of_skus:


        forecast = sarimax_run(df,sku)


        f.write(sku.strip() +"," + str(sum(forecast)))
        f.write("\n")

    f.close()




def doublecheck_forecast_sum():
    pd.set_option('display.max_rows', 1000)

    df_sum = pd.read_csv("sarimax_forecast_sum.txt")

    # print(df)

    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)


    # df_sum['f_sum'] = df_sum.apply(lambda x: help_function_sum_fix(x[0], x[1], df), axis= 1 )

    df_sum['see'] = df_sum.apply(lambda x: help_function_sum_check(x[1]), axis= 1 )

    # print(df_sum)

    df_sum = df_sum.loc[df_sum['see'] == True]

    df_sum = df_sum.drop(['see'],axis=1).reset_index().drop(['index'], axis= 1)

    sku_with_negative_forecast = df_sum['sku'].tolist()

    sku_with_negative_forecast = sku_with_negative_forecast[20: 25]

    for sku in sku_with_negative_forecast:

        sarimax_run(df, "'107099'")


    print(df_sum)

    # df_sum.to_csv(index=False)

def help_function_sum_check(f_sum ):

    # print(sku, sum)

    if f_sum < 0 or f_sum > 600:
        # print(sku, f_sum)

        return True

    return False


def help_function_sum_fix(sku,f_sum, df):

    # print(sku, sum)

    if f_sum < 0 or f_sum > 200:
        # print(sku, f_sum)
        forecast = sarimax_run(df, sku)
        print("foc",sku, f_sum, forecast)
        return sum(forecast)


    return f_sum

def help_function_sum_fix(x):

    x = math.floor(x)

    if x < 0:
        return 0

    if x > 400:
        # bør egentlig kjøre en ny type forecasting her
        # setter bare til 360 for øyeblikket

        return 360


    return x

def fix_forecast_sum():
    # pd.set_option('display.max_rows', 1000)

    df_sum = pd.read_csv("arima_forecast_sum.txt")



    df_sum['f_sum'] = df_sum.apply(lambda x: help_function_sum_fix(x[1]) , axis= 1 )

    df_sum

    print(df_sum)

    return df_sum





def run_traditinal_abc_with_forecast():
    df = fix_forecast_sum()
    print(df)
    df.rename(columns ={'f_sum': 'nr'} , inplace = True)
    # traditional_abc(df).to_csv("abc_arima", index = False)
    return df

def run_traditinal_abc_42_weeks_in_2020_and_10_in_2019():
    print("fix")


    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    # sarimax_run(df, "'107099'")
    df['date'] = pd.to_datetime(df['date'], dayfirst= True)
    # df.loc[df['date'] >= datetime.strftime(startdate,'%d/%m/%y')]
    df = df[(df['date'] > '2019-10-20') & (df['date'] < '2020-10-21')]

    df = df.groupby('sku').sum()


    # df.loc[datetime.date(year=2014,month=1,day=1):datetime.date(year=2014,month=2,day=1)]
    print(df)

    # traditional_abc(df).to_csv("abc_from_oktober_to_oktober", index=False)

    return df



def run_test_data_abc():
    print('test_data_abc')


    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    # sarimax_run(df, "'107099'")
    df['date'] = pd.to_datetime(df['date'], dayfirst= True)
    # df.loc[df['date'] >= datetime.strftime(startdate,'%d/%m/%y')]
    df = df[(df['date'] > '2020-10-25')]

    df = df.groupby('sku').sum()

    # df['sku'] = df['sku'].apply(lambda x: x.strip())

    # traditional_abc(df).to_csv("abc_test_data", index=False)

    return df


    # print(df)

def comparing_classification(df_forecast,df_test_data):


    # df_forecast= pd.read_csv("new_abc_forecast")
    # df_test_data = pd.read_csv("new_abc_real_data")

    # df_forecast = df_forecast.drop(['nr'],axis=1)
    # df_test_data = df_test_data.drop(['nr'],axis=1)

    # df_test_data['sku'] = df_test_data['sku'].apply(lambda x: x.strip())


    pd.set_option('display.max_rows', 1000)
    list_of_skus= df_test_data['sku'].unique()

    df = df_forecast.set_index('sku').join(df_test_data.set_index('sku'),lsuffix='_forecast', rsuffix='_real' )

    # print(df)

    return df

def comparing_classification_benchmark():


    df_forecast= pd.read_csv("abc_from_oktober_to_oktober")

    df_test_data = pd.read_csv("abc_test_data")

    # print(df_test_data, "sher")
    # df_forecast = df_forecast.drop(['nr'],axis=1)
    # df_test_data = df_test_data.drop(['nr'],axis=1)

    df_test_data['sku'] = df_test_data['sku'].apply(lambda x: x.strip())
    df_forecast['sku'] = df_forecast['sku'].apply(lambda x: x.strip())


    # pd.set_option('display.max_rows', 1000)
    list_of_skus= df_test_data['sku'].unique()

    # df = df_test_data.set_index('sku').join(df_forecast.set_index('sku'),lsuffix='_real', rsuffix='_forecast')
    df = df_forecast.set_index('sku').join(df_test_data.set_index('sku'),lsuffix='_forecast', rsuffix='_real' )

    print(df)

    return df

def rate_classification(df_forecast, df_real_data):
    print("rate")
    df = comparing_classification(df_forecast, df_real_data)
    # df = comparing_classification_benchmark()

    df['score'] = df.apply(lambda x: help_function_rate_classification(x['abc_forecast'], x['abc_real']), axis=1)
    # print(df)

    df_A = df['abc_real'] == 'A'
    df_A = df[df_A]
    # print(df_A)

    comparing_df_A = df['abc_forecast'] == 'A'
    comparing_df_A = df[comparing_df_A]
    # print(comparing_df_A)

    df_B = df['abc_real'] == 'B'
    df_B = df[df_B]
    # print(df_B)

    comparing_df_B = df['abc_forecast'] == 'B'
    comparing_df_B = df[comparing_df_B]
    # print(comparing_df_B)

    df_C = df['abc_real'] == 'C'
    df_C = df[df_C]
    # print(df_C)

    comparing_df_C = df['abc_forecast'] == 'C'
    comparing_df_C = df[comparing_df_C]
    # print(comparing_df_C)


    df_nan = df['abc_real'].apply(lambda x: isinstance(x, float))
    df_nan = df[df_nan]
    # print(df_nan)


    print('A:',df_A['score'].sum(), len(df_A),len(comparing_df_A), 'B:',df_B['score'].sum(), len(df_B),len(comparing_df_B),'C:',df_C['score'].sum(), len(df_C),len(comparing_df_C),'nan:',df_nan['score'].sum(), len(df_nan) , len(df)  )

def help_function_rate_classification(abc_forecast, abc_real):
    # print(abc_real)
    if abc_real == abc_forecast:
        return 1
    # abc_real =="nan" and abc_forecast =='C'
    if (isinstance(abc_real, float) and abc_forecast =='C' ):
        return 1

    return 0



def forcast_arima(train):


    p=q=range(0,3)
    d= range(0,2)
    pdq = list(itertools.product(p,d,q))
    warnings.filterwarnings('ignore')
    combs = {}
    aics = []


    for param in pdq:
        try:
            model_arima = ARIMA(train,order=param)
            model_arima_fit = model_arima.fit()
            # print(param,math.floor(model_arima_fit.aic))
            # resultlist_pdq.append((param,model_arima_fit.aic))
            combs.update({model_arima_fit.aic : param})
            aics.append(model_arima_fit.aic)



        except:
            continue

    best_aic = min(aics)# Modeling and forcasting
    model = ARIMA(train,order=combs[best_aic])
    print(combs[best_aic], "potet")
    model = model.fit()
    forecast = model.forecast(11)[0]
    print(forecast, "siv")
    return forecast


def arima_run(df, sku):

    df_time_series= plot_a_sku(df.copy(),sku)

    train,test = making_week_df_and_split_into_train_and_testr(df_time_series, sku)

    forecast = forcast_arima(train)

    plot_predicted_value_and_test(forecast,test)
    error_evaluation(test, forecast)

    # plt.show()

    return forecast

def arima_run_for_MSE(df, sku):

    df_time_series= plot_a_sku(df.copy(),sku)

    train,test = making_week_df_and_split_into_train_and_testr(df_time_series, sku)

    forecast = forcast_arima(train)

    # plot_predicted_value_and_test(forecast,test)
    MSE_error = error_evaluation(test, forecast)

    # plt.show()

    return MSE_error

def write_arima_forecast_sum_to_file():
    print("forecast to file")
    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    list_of_skus= df['sku'].unique()
    # arima_run(df,list_of_skus[0])
    # print(list_of_skus[0])
    # arima_run(df,list_of_skus[0])
    f = open("arima_forecast_sum.txt", "a")

    list_of_skus = list_of_skus[600:]

    for sku in list_of_skus:


        forecast = arima_run(df,sku)


        f.write(sku.strip() +"," + str(sum(forecast)))
        f.write("\n")

    f.close()



def forcast_AR(train):

    warnings.filterwarnings('ignore', 'statsmodels.tsa.ar_model.AR', FutureWarning)

    warnings.warn(AR_DEPRECATION_WARN, FutureWarning)



    model_ar = AR(train)
    model_ar_fit = model_ar.fit()

    predictions = model_ar_fit.predict(start=90,end=104)


def AR_run(df, sku):

    df_time_series= plot_a_sku(df.copy(),sku)

    train,test = making_week_df_and_split_into_train_and_testr(df_time_series, sku)

    forecast = forcast_AR(train)

    plot_predicted_value_and_test(forecast,test)


    return forecast


def calulate_time_used(comparing_df):

    # pd.set_option('display.max_rows', 2000)
    df_real= pd.read_csv("new_abc_real_data")
    # df_real['sku'] = df_real.apply(lambda x: x[0].strip().replace("'", ""), axis = 1)
    # print(df_real)
    dict_real = df_real.set_index('sku').T.to_dict()
    # print(dict_real)
    # print(dict_real)
    # comparing_df['sku'] = comparing_df.apply(lambda x: (x[0].strip().replace("'", "")), axis = 1)

    # print(dict_real)
    # add
    real_list_of_skus = list(dict_real.keys())
    # print(dict_real[112442])
    comparing_list_of_skus= comparing_df['sku'].to_list()

    # print(real_list_of_skus)
    # print(comparing_list_of_skus)

    # res = [x for x in real_list_of_skus + comparing_list_of_skus if x not in comparing_list_of_skus]
    #
    # # print(comparing_df)
    # df_missing_sku = pd.DataFrame(res, columns=['sku'])
    #
    # df_missing_sku['nr'] = 0
    #
    # df_missing_sku['abc'] = 'C'
    #
    # comparing_df= comparing_df.append(df_missing_sku)


    # print(comparing_df)
    comparing_df['time_used'] = comparing_df.apply(lambda x: help_function_calulate_time(x[0], x[1],x[2],dict_real), axis= 1)
    #


    # print(comparing_df)
    print(comparing_df['time_used'].sum())


def help_function_calulate_time(sku, nr ,abc, dict_real):
    # print(type(sku), abc, dict_real[int(sku)])
    # a= 90
    # b= 140
    # c= 200

    a= 83
    b= 167
    c= 275
    # sku = sku.strip().replace("'", "")

    sku = int(sku)

    if sku in dict_real.keys():

        if abc == 'A' :
            return dict_real[sku]['nr']*a

        if abc == 'B' :
            return dict_real[sku]['nr']*b

        if abc == 'C' :
            return dict_real[sku]['nr']*c
    else:

        return 0


def new_abc_with_same_amount_of_products():

    pd.set_option('display.max_rows', 50)

    # .apply(lambda x: x[0].strip().replace("'", ""), axis = 1)

    df_forecast =run_traditinal_abc_with_forecast()
    df_last_year = run_traditinal_abc_42_weeks_in_2020_and_10_in_2019().reset_index()
    df_real_data= run_test_data_abc().reset_index()

    df_forecast['sku']= df_forecast.apply(lambda x: x[0].strip().replace("'", ""), axis = 1)
    df_last_year['sku'] =df_last_year.apply(lambda x: x[0].strip().replace("'", ""), axis = 1)
    df_real_data['sku'] =df_real_data.apply(lambda x: x[0].strip().replace("'", ""), axis = 1)

    list_forecast =df_forecast["sku"].tolist()
    list_last_year = df_last_year["sku"].tolist()
    list_real_data = df_real_data["sku"].tolist()

    print(list_forecast)

    # print(df_last_year)
    # print(df_forecast)
    # print(df_real_data)

    real_data_appendix = [x for x in list_real_data + list_last_year if x not in list_real_data]

    last_year_appendix = [x for x in list_real_data + list_last_year if x not in list_last_year]

    keep_in_forecast = [x for x in list_forecast if x  in list_real_data or  x in list_last_year]

    print(real_data_appendix)

    df_real_data_appendix = pd.DataFrame(real_data_appendix, columns=['sku'])
    df_real_data_appendix['nr'] = 0

    # df_real_data_appendix['abc'] = 'C'

    # df_last_year


    df_real_data = df_real_data.append(df_real_data_appendix)

    print(df_real_data)

    df_last_year_appendix = pd.DataFrame(last_year_appendix, columns=['sku'])
    df_last_year_appendix['nr'] = 0

    df_last_year = df_last_year.append(df_last_year_appendix)

    # df[df['A'].isin([3, 6])]

    df_forecast = df_forecast[df_forecast['sku'].isin( keep_in_forecast)]

    print(df_forecast)

    return df_forecast,df_real_data,df_last_year

    # traditional_abc(df_forecast)
        # .to_csv("new_abc_forecast", index = False)
    # traditional_abc(df_last_year)
    #     # .to_csv("new_abc_form_october_to_october", index = False)
    # traditional_abc(df_real_data)
    #     # .to_csv("new_abc_real_data",index = False )



def new_abc_segmentation(percent):
    if percent > 0 and percent < 0.10:
        return 'A'
    elif percent >= 0.10 and percent < 0.30:
        return 'B'
    elif percent >= 0.3:
        return 'C'

def run_new_abc_with_equal_size_of_class(df):


    df = df.sort_values(by=['nr'], ascending=False)
    df= df.reset_index()
    # print(df)
    df= df.drop(['index'], axis=1)

    # print(df_forecast)

    df['NrCumCost'] = df['nr'].cumsum()
    df['Count'] = 1
    df['TotalNrOfSkus'] = df['Count'].sum()
    df['SkuCum'] = df['Count'].cumsum()
    df['SkuPercent'] = df['SkuCum']/df['TotalNrOfSkus']
    df['TotalSum'] = df['nr'].sum()
    df['NrPercent'] =  df['NrCumCost']/df['TotalSum']

    df['abc'] = df['SkuPercent'].apply(new_abc_segmentation)

    pd.set_option('display.max_rows', 1000)
    df = df.drop(['NrCumCost','TotalSum','NrPercent','SkuPercent', 'Count','SkuCum','TotalNrOfSkus' ], axis=1)

    # print(df)
    calulate_time_used(df)
    # print(calulate_time_used(df))
    # df= df.drop(['index'], axis=1)
    return df

def run_new_abc_for_plot(df):


    df = df.sort_values(by=['nr'], ascending=False)
    df= df.reset_index()
    # print(df)
    df= df.drop(['index'], axis=1)

    # print(df_forecast)

    df['NrCumCost'] = df['nr'].cumsum()
    df['Count'] = 1
    df['TotalNrOfSkus'] = df['Count'].sum()
    df['SkuCum'] = df['Count'].cumsum()
    df['SkuPercent'] = df['SkuCum']/df['TotalNrOfSkus']
    df['TotalSum'] = df['nr'].sum()
    df['NrPercent'] =  df['NrCumCost']/df['TotalSum']

    df['abc'] = df['SkuPercent'].apply(new_abc_segmentation)

    pd.set_option('display.max_rows', 1000)
    # df = df.drop(['NrCumCost','TotalSum','NrPercent','SkuPercent', 'Count','SkuCum','TotalNrOfSkus' ], axis=1)

    # print(df)
    # calulate_time_used(df)
    # print(calulate_time_used(df))
    # df= df.drop(['index'], axis=1)
    return df

def make_forcast_plot():
    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    # list_of_skus= df['sku'].unique()
    # 112442, 112983, 112058, 702972, 881906 "'112442'", "'112492'", "'100295'", "'113706'", "'112626'",
    list_of_skus =   [ "'112626'", "'113888'","'113843'" ]
    for sku in list_of_skus:
        arima_run(df, sku)
        # plt.show()


def error_evaluation(test, forecast):
    print('error')

    error = mean_squared_error(test, forecast)

    print(error, 'MSE ')

    return error
    # mean_squared_error()

def write_arima_forecast_MSE_to_file():
    print("forecast error to file")
    df = setup_data_2019_2020()
    df = run_pallet_df_maker(df)
    list_of_skus= df['sku'].unique()
    # arima_run(df,list_of_skus[0])
    # print(list_of_skus[0])
    # arima_run(df,list_of_skus[0])
    f = open("arima_forecast_MSE.txt", "a")

    list_of_skus = list_of_skus[600:]

    for sku in list_of_skus:


        MSE_error = arima_run_for_MSE(df,sku)



        f.write(sku.strip() +"," + str(MSE_error))
        f.write("\n")

    f.close()


def plot_abc(df_forecast, df_last_year, df_real):
    plt.style.use('seaborn-whitegrid')
    plt.figure(figsize=(6, 6))
    ax = plt.axes()
    ax.set_xlim(0,1)
    ax.set_ylim(0,1)

    # plot data
    ax.plot(df_forecast["SkuPercent"], df_forecast["NrPercent"], linewidth=3, color = 'blue')
    ax.plot(df_last_year["SkuPercent"], df_last_year["NrPercent"], linewidth=3, color = 'green')
    ax.plot(df_real["SkuPercent"], df_real["NrPercent"], linewidth=3, color = 'red')

    xpoints = [0.1, 0.3]

    colors = ['black', 'black']

    for p, c in zip(xpoints, colors):

        plt.axvline(p,  label='line: {}'.format(p), c=c)



    plt.annotate('A', [0.05, 0.1], fontsize=12, color='black')
    plt.annotate('B', [0.19, 0.1], fontsize=12, color='black')
    plt.annotate('C', [0.5, 0.1], fontsize=12, color='black')


# add legend
    plt.annotate('class borders', [0.81, 0.16], fontsize=12, color='black')
    plt.annotate('forecast orders', [0.81, 0.12], fontsize=12, color='blue')
    plt.annotate('last years orders', [0.81, 0.08], fontsize=12, color='green')
    plt.annotate('actual orders', [0.81, 0.04], fontsize=12, color='red')

    # show complete plot
    plt.show()

def find_average_MSE():

    df = pd.read_csv('arima_forecast_MSE.txt')
    mean =df['MSE'].mean()
    min =df['MSE'].min()
    max =df['MSE'].max()
    median =df['MSE'].median()
    print(mean, min, max, median)


# Press the green button in the gutter to run the script.
if __name__ == '__main__':
    print('text')

    find_average_MSE()

    # write_date_and_nr_to_file_to_get_pallet_nr()
    # find_nr_pr_pallet()
    # df = run_pallet_df_maker()
    # plot_a_sku(df, "'100295'")
    # plt.show()
    # df = run_pallet_df_maker()
    # print(data_transformation_for_old_classification())
    # plot_a_sku(df,"'113844'")
    # df= data_transformation_for_old_classification()
    # traditional_abc(df)
    # abc_clustering()

    # write_forecast_sum_to_file()
    # forecast_checker()
    # plt.show()

    # write_date_and_nr_to_file_to_get_pallet_nr()
    # doublecheck_forecast_sum()
    # fix_forecast_sum()

    # run_traditinal_abc_with_forecast()
    # run_traditinal_abc_42_weeks_in_2020_and_10_in_2019()
    # run_test_data_abc()

    # comparing_classification()
    # rate_classification()
    #
    # calulate_time_used(pd.read_csv("new_abc_real_data"))
    # calulate_time_used(pd.read_csv("new_abc_form_october_to_october"))
    # calulate_time_used(pd.read_csv("new_abc_forecast"))

    # new_abc_with_same_amount_of_products()
    # df_forecast,df_real_data,df_last_year= new_abc_with_same_amount_of_products()
    # df_forecast = run_new_abc_with_equal_size_of_class(df_forecast)
    # df_real_data = run_new_abc_with_equal_size_of_class(df_real_data)
    # df_last_year= run_new_abc_with_equal_size_of_class(df_last_year)
    #
    # df_forecast.drop(['time_used'],axis=1).to_csv("master_abc_forecast",index=False)
    # df_real_data.drop(['time_used'],axis=1).to_csv("master_abc_real",index=False)
    # df_last_year.drop(['time_used'],axis=1).to_csv("master_abc_last_year", index=False)

    # write_arima_forecast_MSE_to_file()

    # df_forecast = run_new_abc_for_plot(df_forecast)
    # df_real_data = run_new_abc_for_plot(df_real_data)
    # df_last_year= run_new_abc_for_plot(df_last_year)
    # pd.set_option('display.max_columns', 10)
    #
    # # # print(df_last_year)
    # # calulate_time_used(df_forecast)
    # # calulate_time_used(df_real_data)
    # # calulate_time_used(df_last_year)
    # rate_classification(df_last_year, df_real_data)
    # rate_classification(df_forecast, df_real_data)


    # plot_abc(df_forecast,df_last_year,df_real_data)
    # plot_abc(df_last_year)
    # plot_abc(df_real_data)

    # make_forcast_plot()

    # write_arima_forecast_sum_to_file()
    # run_traditinal_abc_with_forecast()
    # write_date_and_nr_to_file_to_get_pallet_nr()
    # print_hi()
    # pd.set_option('display.max_rows', 1000)
    # df = pd.read_csv('data1/part-00000')
    # df.columns = df.columns.str.replace('[()]', '')
    # df = df.replace('[()]', '', regex=True)
    #
    # print(df)
    # sarimax_run()
    # select_skus_to_forecast__remove_superpopular_skus(df)

    # list_of_skus= df['sku'].unique()
    #
    # print(list_of_skus[0],"'112148'" )
    # print(list_of_skus[0].strip() == "'112148'")

    # yearly_most_sales(df.copy())
    # df_time_series= plot_a_sku(df.copy(),"'100295'")

    # print(plot_a_sku(df,"'111001'"))
    # plot_every_sku(skuList=list_of_skus,df= df.copy())

    # forcast_of_sku(df_time_series.copy())

    # forcast_of_sku_arima(df_time_series.copy())

    # forcast_of_new_sku_arima(df_time_series)

    # plot_monthly_data(list_of_skus,df.copy())
    # print_hi()
    # from_text_to_df()
    # plot_fake_data()


# See PyCharm help at https://www.jetbrains.com/help/pycharm/
